diff -uNr mythtv-0.21/libs/libmythtv/videoout_quartz.cpp mythtv/libs/libmythtv/videoout_quartz.cpp
--- mythtv-0.21/libs/libmythtv/videoout_quartz.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/videoout_quartz.cpp	2008-11-19 11:14:13.000000000 +0100
@@ -1619,23 +1492,23 @@
 
 void VideoOutputQuartz::Exit(void)
 {
-    if (Started) 
+    if (Started)
     {
         Started = false;
 
         // Restore main window
         // (assuming it was shrunk i.e. we were not in full screen mode)
         if (data->windowedMode)
-        { 
+        {
             VERBOSE(VB_PLAYBACK,
-                    QString("Restoring Main Window to %1x%2")  
+                    QString("Restoring Main Window to %1x%2")
                     .arg(data->windowBounds.right - data->windowBounds.left)
                     .arg(data->windowBounds.bottom - data->windowBounds.top));
             SetWindowBounds(data->window, kWindowStructureRgn,
                             &(data->windowBounds));
-        } 
+        }
 
-        data->views.clear();
+        data->ClearViews();
         DeleteQuartzBuffers();
     }
 }
@@ -1667,27 +1540,22 @@
 
 void VideoOutputQuartz::EmbedInWidget(WId wid, int x, int y, int w, int h)
 {
-    VERBOSE(VB_PLAYBACK,
-            QString("VideoOutputQuartz::EmbedInWidget(wid=%1, x=%2, y=%3, w=%4, h=%5)")
-                   .arg(wid)
-                   .arg(x)
-                   .arg(y)
-                   .arg(w)
-                   .arg(h));
+    VERBOSE(VB_PLAYBACK, "VideoOutputQuartz::EmbedInWidget(" +
+            QString("wid=%1, x=%2, y=%3, w=%4, h=%5)")
+            .arg(wid).arg(x).arg(y).arg(w).arg(h));
 
     if (embedding)
         return;
 
     VideoOutput::EmbedInWidget(wid, x, y, w, h);
-    
+
     data->pixelLock.lock();
 
     // warn other views that embedding is starting
-    for (VideoOutputQuartzView *view = data->views.first();
-         view;
-         view = data->views.next())
+    vector<VideoOutputQuartzView*>::iterator it = data->views.begin();
+    for (; it != data->views.end(); ++it)
     {
-        view->EmbedChanged(true);
+        (*it)->EmbedChanged(true);
     }
 
     // create embedded widget
@@ -1695,9 +1563,9 @@
     if (data->embeddedView)
     {
         data->embeddedView->Init();
-        data->views.append(data->embeddedView);
+        data->views.push_back(data->embeddedView);
     }
-    
+
     data->pixelLock.unlock();
 }
 
@@ -1712,22 +1580,25 @@
     VideoOutput::StopEmbedding();
 
     data->pixelLock.lock();
-    
+
     // delete embedded widget
     if (data->embeddedView)
     {
-        data->views.removeRef(data->embeddedView);
+        vector<VideoOutputQuartzView*>::iterator it =
+            find(data->views.begin(), data->views.end(), data->embeddedView);
+        if (it != data->views.end())
+        {
+            delete *it;
+            data->views.erase(it);
+        }
         data->embeddedView = NULL;
     }
 
     // tell other views to return to normal
-    for (VideoOutputQuartzView *view = data->views.first();
-         view;
-         view = data->views.next())
-    {
-        view->EmbedChanged(false);
-    }
-    
+    vector<VideoOutputQuartzView*>::iterator it = data->views.begin();
+    for (; it != data->views.end(); ++it)
+        (*it)->EmbedChanged(false);
+
     data->pixelLock.unlock();
 }
 
@@ -1765,12 +1636,9 @@
 #endif // USING_DVDV
 
     data->pixelLock.lock();
-    for (VideoOutputQuartzView *view = data->views.first();
-         view;
-         view = data->views.next())
-    {
-        view->Show();
-    }
+    vector<VideoOutputQuartzView*>::iterator it = data->views.begin();
+    for (; it != data->views.end(); ++it)
+        (*it)->Show();
     data->pixelLock.unlock();
 }
 
diff -uNr mythtv-0.21/libs/libmythtv/videoout_quartz.h mythtv/libs/libmythtv/videoout_quartz.h
--- mythtv-0.21/libs/libmythtv/videoout_quartz.h	2007-10-02 18:23:03.000000000 +0200
+++ mythtv/libs/libmythtv/videoout_quartz.h	2008-11-04 12:38:23.000000000 +0100
@@ -23,6 +23,7 @@
                       MythCodecID  av_codec_id,
                       void        *codec_private);
     void VideoAspectRatioChanged(float aspect);
+    void MoveResize(void);
     void Zoom(ZoomDirection direction);
 
     void EmbedInWidget(WId wid, int x, int y, int w, int h);
diff -uNr mythtv-0.21/libs/libmythtv/videoout_xv.cpp mythtv/libs/libmythtv/videoout_xv.cpp
--- mythtv-0.21/libs/libmythtv/videoout_xv.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/videoout_xv.cpp	2008-04-02 19:52:17.000000000 +0200
@@ -3820,10 +3820,11 @@
     int port_min = xv_attribute_min[attribute];
     int port_max = xv_attribute_max[attribute];
     int range    = port_max - port_min;
-    
-    int tmpval = (int) roundf(range * 0.01f * newValue);
-    int value   = min(tmpval + port_min, port_max);
 
+    int tmpval2 = (newValue + valAdj) % 100; 
+    int tmpval3 = (int) roundf(range * 0.01f * tmpval2); 
+    int value   = min(tmpval3 + port_min, port_max); 
+    
     xv_set_attrib(XJ_disp, xv_port, attrName.ascii(), value);
 
 #ifdef USING_XVMC
diff -uNr mythtv-0.21/libs/libmythtv/videosource.cpp mythtv/libs/libmythtv/videosource.cpp
--- mythtv-0.21/libs/libmythtv/videosource.cpp	2008-02-27 01:46:30.000000000 +0100
+++ mythtv/libs/libmythtv/videosource.cpp	2008-12-31 20:00:27.000000000 +0100
@@ -451,6 +451,8 @@
     QString filename = QString("%1/%2.xmltv")
         .arg(MythContext::GetConfDir()).arg(parent.getSourceName());
 
+    gContext->SaveSetting(QString("XMLTVConfig.%1").arg(parent.getSourceName()), filename);
+
     command = QString("%1 --config-file '%2' --configure")
         .arg(grabber).arg(filename);
 
@@ -1635,7 +1637,7 @@
         QObject::tr("MJPEG capture card (Matrox G200, DC10)"), "MJPEG");
 # ifdef USING_IVTV
     setting->addSelection(
-        QObject::tr("MPEG-2 encoder card (PVR-x50, PVR-500)"), "MPEG");
+        QObject::tr("IVTV MPEG-2 encoder card"), "MPEG");
 # endif // USING_IVTV
 #endif // USING_V4L
 
diff -uNr mythtv-0.21/libs/libmythtv/vsync.cpp mythtv/libs/libmythtv/vsync.cpp
--- mythtv-0.21/libs/libmythtv/vsync.cpp	2007-12-12 17:56:32.000000000 +0100
+++ mythtv/libs/libmythtv/vsync.cpp	2009-04-19 23:30:15.000000000 +0200
@@ -16,6 +16,7 @@
  * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */
 
+#include <cstdlib>
 #include <cstdio>
 #include <cerrno>
 #include <cmath>
diff -uNr mythtv-0.21/libs/libmythui/libmythui.pro mythtv/libs/libmythui/libmythui.pro
--- mythtv-0.21/libs/libmythui/libmythui.pro	2008-01-31 23:18:37.000000000 +0100
+++ mythtv/libs/libmythui/libmythui.pro	2008-06-04 06:05:51.000000000 +0200
@@ -84,3 +84,5 @@
         inc.files += mythpainter_ogl.h
     }
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythui/myththemedmenu.cpp mythtv/libs/libmythui/myththemedmenu.cpp
--- mythtv-0.21/libs/libmythui/myththemedmenu.cpp	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythui/myththemedmenu.cpp	2008-10-02 02:54:20.000000000 +0200
@@ -2157,7 +2157,8 @@
         }
         else
         {
-            if (ThemedButton *button = reinterpret_cast<ThemedButton*>(origtype))
+            ThemedButton *button = dynamic_cast<ThemedButton*>(origtype);
+            if (button)
             {
                 ThemedButton *lastbutton = activebutton;
                 activebutton = button;
diff -uNr mythtv-0.21/libs/libmythupnp/httprequest.cpp mythtv/libs/libmythupnp/httprequest.cpp
--- mythtv-0.21/libs/libmythupnp/httprequest.cpp	2008-03-04 04:14:01.000000000 +0100
+++ mythtv/libs/libmythupnp/httprequest.cpp	2009-01-04 01:25:34.000000000 +0100
@@ -180,6 +180,17 @@
 
     sHeader += GetAdditionalHeaders();
 
+    // ----------------------------------------------------------------------
+    // Temp Hack to process DLNA header
+                             
+    QString sValue = GetHeaderValue( "getcontentfeatures.dlna.org", "0" );
+
+    if (sValue == "1")
+        sHeader += "contentFeatures.dlna.org: DLNA.ORG_OP=01;DLNA.ORG_CI=0;"
+                   "DLNA.ORG_FLAGS=01500000000000000000000000000000\r\n";
+
+    // ----------------------------------------------------------------------
+
     sHeader += QString( "Connection: %1\r\n"
                         "Content-Type: %2\r\n"
                         "Content-Length: %3\r\n" )
diff -uNr mythtv-0.21/libs/libmythupnp/libmythupnp.pro mythtv/libs/libmythupnp/libmythupnp.pro
--- mythtv-0.21/libs/libmythupnp/libmythupnp.pro	2008-01-23 07:02:16.000000000 +0100
+++ mythtv/libs/libmythupnp/libmythupnp.pro	2008-06-04 06:05:51.000000000 +0200
@@ -43,6 +43,9 @@
 LIBS += $$EXTRA_LIBS
 
 mingw {
+    # For easier debugging: 
+    target.path = $${PREFIX}/bin
+
     HEADERS += darwin-sendfile.h
     SOURCES += darwin-sendfile.c
 }
@@ -70,3 +73,5 @@
 
     QMAKE_LFLAGS_SHLIB += -flat_namespace
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythupnp/ssdp.cpp mythtv/libs/libmythupnp/ssdp.cpp
--- mythtv-0.21/libs/libmythupnp/ssdp.cpp	2007-12-18 03:51:27.000000000 +0100
+++ mythtv/libs/libmythupnp/ssdp.cpp	2008-03-15 18:53:54.000000000 +0100
@@ -251,7 +251,7 @@
         // Parse request Type
         // ------------------------------------------------------------------
 
-        // cout << "SSDP::ProcessData - requestLine: " << sRequestLine << endl;
+        VERBOSE(VB_UPNP, QString( "SSDP::ProcessData - requestLine: %1" ).arg( sRequestLine ));
 
         SSDPRequestType eType = ProcessRequestLine( sRequestLine );
 
@@ -349,7 +349,9 @@
     QString sMX  = GetHeaderValue( sHeaders, "MX" , "" );
     int     nMX  = 0;
 
-    //cout << "*** SSDP ProcessSearchrequest : [" << sST << "] MX = " << nMX << endl;
+    VERBOSE( VB_UPNP, QString( "SSDP::ProcessSearchrequest : [%1] MX=%2" )
+                         .arg( sST )
+                         .arg( nMX ));
 
     // ----------------------------------------------------------------------
     // Validate Header Values...
@@ -388,7 +390,7 @@
         // Excute task now for fastest response & queue for time-delayed response
         // -=>TODO: To be trully uPnp compliant, this Execute should be removed.
 
-        pTask->Execute( NULL );
+        //pTask->Execute( NULL );
 
         UPnp::g_pTaskQueue->AddTask( nNewMX, pTask );
 
@@ -433,6 +435,16 @@
     QString sUSN     = GetHeaderValue( headers, "USN"           , "" );
     QString sCache   = GetHeaderValue( headers, "CACHE-CONTROL" , "" );
 
+    VERBOSE( VB_UPNP, QString( "SSDP::ProcessSearchResponse \n"
+                               "DescURL=%1\n"
+                               "ST     =%2\n"
+                               "USN    =%3\n"
+                               "Cache  =%4")
+                         .arg( sDescURL )
+                         .arg( sST      )
+                         .arg( sUSN     )
+                         .arg( sCache   ));
+
     int nPos = sCache.find( "max-age", 0, false );
 
     if (nPos < 0)
@@ -460,6 +472,19 @@
     QString sUSN     = GetHeaderValue( headers, "USN"           , "" );
     QString sCache   = GetHeaderValue( headers, "CACHE-CONTROL" , "" );
 
+    VERBOSE( VB_UPNP, QString( "SSDP::ProcessNotify\n"
+                               "DescURL=%1\n"
+                               "NTS    =%2\n"
+                               "NT     =%3\n"
+                               "USN    =%4\n"
+                               "Cache  =%5" )
+                         .arg( sDescURL )
+                         .arg( sNTS     )
+                         .arg( sNT      )
+                         .arg( sUSN     )
+                         .arg( sCache   ));
+
+
     if (sNTS.contains( "ssdp:alive"))
     {
         int nPos = sCache.find( "max-age", 0, false );
@@ -559,6 +584,12 @@
 
     QString sUserAgent = pRequest->GetHeaderValue( "User-Agent", "" );
 
+    VERBOSE( VB_UPNP, QString( "SSDPExtension::GetDeviceDesc - Host=%1 Port=%2 UserAgent=%3" )
+                         .arg( pRequest->GetHostAddress() )
+                         .arg( m_nServicePort )
+                         .arg( sUserAgent ));
+
+
     UPnp::g_UPnpDeviceDesc.GetValidXML( pRequest->GetHostAddress(), 
                                         m_nServicePort,
                                         pRequest->m_response,
@@ -578,11 +609,18 @@
 
     if (QFile::exists( pRequest->m_sFileName ))
     {
+        VERBOSE( VB_UPNP, QString( "SSDPExtension::GetFile( %1 ) - Exists" )
+                             .arg( pRequest->m_sFileName ));
 
         pRequest->m_eResponseType                     = ResponseTypeFile;
         pRequest->m_nResponseStatus                   = 200;
         pRequest->m_mapRespHeaders[ "Cache-Control" ] = "no-cache=\"Ext\", max-age = 5000";
     }
+    else
+    {
+        VERBOSE( VB_UPNP, QString( "SSDPExtension::GetFile( %1 ) - Not Found" )
+                             .arg( pRequest->m_sFileName ));
+    }
 
 }
 
@@ -596,6 +634,8 @@
     int           nCount = 0;
     NameValueList list;
 
+    VERBOSE( VB_UPNP, "SSDPExtension::GetDeviceList" );
+
     cache.Lock();
 
     QString     sXML;
diff -uNr mythtv-0.21/libs/libmythupnp/upnpcds.cpp mythtv/libs/libmythupnp/upnpcds.cpp
--- mythtv-0.21/libs/libmythupnp/upnpcds.cpp	2008-03-02 22:14:41.000000000 +0100
+++ mythtv/libs/libmythupnp/upnpcds.cpp	2008-09-25 22:48:00.000000000 +0200
@@ -1,11 +1,11 @@
 //////////////////////////////////////////////////////////////////////////////
 // Program Name: upnpcds.cpp
-//                                                                            
-// Purpose - uPnp Content Directory Service 
-//                                                                            
+//
+// Purpose - uPnp Content Directory Service
+//
 // Created By  : David Blain                    Created On : Oct. 24, 2005
-// Modified By :                                Modified On:                  
-//                                                                            
+// Modified By :                                Modified On:
+//
 //////////////////////////////////////////////////////////////////////////////
 
 #include "upnp.h"
@@ -39,11 +39,11 @@
 {
     QString sXML;
 
-    for ( CDSObject *pObject  = m_List.first(); 
+    for ( CDSObject *pObject  = m_List.first();
                      pObject != NULL;
                      pObject  = m_List.next() )
     {
-        sXML += pObject->toXml();    
+        sXML += pObject->toXml();
     }
 
     return( sXML );
@@ -167,7 +167,7 @@
             default:
                 UPnp::FormatErrorResponse( pRequest, UPnPResult_InvalidAction );
                 break;
-        }       
+        }
 
         return true;
     }
@@ -232,7 +232,7 @@
         // ------------------------------------------------------------------
 
         switch( request.m_eBrowseFlag )
-        { 
+        {
             case CDS_BrowseMetadata:
             {
                 // ----------------------------------------------------------------------
@@ -334,7 +334,7 @@
             delete pResult;
         }
     }
-    
+
     // ----------------------------------------------------------------------
     // Output Results of Browse Method
     // ----------------------------------------------------------------------
@@ -388,7 +388,7 @@
                         .arg(request.m_sContainerID));
 
     // ----------------------------------------------------------------------
-    // Break the SearchCriteria into it's parts 
+    // Break the SearchCriteria into it's parts
     // -=>TODO: This DOES NOT handle ('s or other complex expressions
     // ----------------------------------------------------------------------
 
@@ -403,9 +403,9 @@
     //          Just focus on the "upnp:class derivedfrom" expression
     // ----------------------------------------------------------------------
 
-    for ( QStringList::Iterator it  = request.m_sSearchList.begin(); 
-                                it != request.m_sSearchList.end(); 
-                              ++it ) 
+    for ( QStringList::Iterator it  = request.m_sSearchList.begin();
+                                it != request.m_sSearchList.end();
+                              ++it )
     {
         if ( (*it).contains( "upnp:class derivedfrom", FALSE ) > 0)
         {
@@ -607,9 +607,9 @@
     if (pResults != NULL)
     {
 
-        if (key)  
-            idPath.last().append(QString("=%1").arg(key)); 
-        else 
+        if (key)
+            idPath.last().append(QString("=%1").arg(key));
+        else
         {
             if (pRequest->m_sObjectId.contains("item"))
             {
@@ -641,7 +641,7 @@
         pResults->m_sErrorDesc = "";
     }
 
-    return( pResults );        
+    return( pResults );
 }
 
 /////////////////////////////////////////////////////////////////////////////
@@ -706,8 +706,8 @@
 //
 /////////////////////////////////////////////////////////////////////////////
 
-UPnpCDSExtensionResults *UPnpCDSExtension::ProcessRoot( UPnpCDSRequest          *pRequest, 
-                                                        UPnpCDSExtensionResults *pResults, 
+UPnpCDSExtensionResults *UPnpCDSExtension::ProcessRoot( UPnpCDSRequest          *pRequest,
+                                                        UPnpCDSExtensionResults *pResults,
                                                         QStringList             &/*idPath*/ )
 {
     pResults->m_nTotalMatches   = 0;
@@ -716,7 +716,7 @@
     short nRootCount = GetRootCount();
 
     switch( pRequest->m_eBrowseFlag )
-    { 
+    {
         case CDS_BrowseMetadata:
         {
             // --------------------------------------------------------------
@@ -730,7 +730,7 @@
 
             pRoot->SetChildCount( nRootCount );
 
-            pResults->Add( pRoot ); 
+            pResults->Add( pRoot );
 
             break;
         }
@@ -740,7 +740,7 @@
 		VERBOSE(VB_UPNP, "CDS_BrowseDirectChildren");
             pResults->m_nUpdateID     = 1;
             pResults->m_nTotalMatches = nRootCount ;
-            
+
             if ( pRequest->m_nRequestedCount == 0)
                 pRequest->m_nRequestedCount = nRootCount ;
 
@@ -758,8 +758,8 @@
                         QString sId = QString( "%1/%2" ).arg( pRequest->m_sObjectId   )
                                                         .arg( nIdx );
 
-                        CDSObject *pItem = CreateContainer( sId,  
-                                                            QObject::tr( pInfo->title ), 
+                        CDSObject *pItem = CreateContainer( sId,
+                                                            QObject::tr( pInfo->title ),
                                                             m_sExtensionId );
 
                         pItem->SetChildCount( GetDistinctCount( pInfo ) );
@@ -793,9 +793,9 @@
     // ----------------------------------------------------------------------
     //
     // ----------------------------------------------------------------------
-    
+
     switch( pRequest->m_eBrowseFlag )
-    { 
+    {
         case CDS_BrowseMetadata:
         {
             // --------------------------------------------------------------
@@ -809,13 +809,13 @@
                 pResults->m_nTotalMatches   = 1;
                 pResults->m_nUpdateID       = 1;
 
-                CDSObject *pItem = CreateContainer( pRequest->m_sObjectId,  
-                                                    QObject::tr( pInfo->title ), 
+                CDSObject *pItem = CreateContainer( pRequest->m_sObjectId,
+                                                    QObject::tr( pInfo->title ),
                                                     m_sExtensionId );
 
                 pItem->SetChildCount( GetDistinctCount( pInfo ) );
 
-                pResults->Add( pItem ); 
+                pResults->Add( pItem );
             }
 
             break;
@@ -834,7 +834,7 @@
             break;
 
     }
-    
+
 
     return pResults;
 }
@@ -844,7 +844,7 @@
 /////////////////////////////////////////////////////////////////////////////
 
 UPnpCDSExtensionResults *UPnpCDSExtension::ProcessItem( UPnpCDSRequest          *pRequest,
-                                                        UPnpCDSExtensionResults *pResults, 
+                                                        UPnpCDSExtensionResults *pResults,
                                                         QStringList             &idPath )
 {
     pResults->m_nTotalMatches   = 0;
@@ -864,18 +864,18 @@
 
             QStringMap  mapParams;
             QString     sParams = idPath.last().section( '?', 1, 1 );
-            sParams.replace(QRegExp( "&amp;"), "&" ); 
+            sParams.replace(QRegExp( "&amp;"), "&" );
 
             HTTPRequest::GetParameters( sParams, mapParams );
 
             MSqlQuery query(MSqlQuery::InitCon());
 
-            if (query.isConnected())                                                           
+            if (query.isConnected())
             {
                 BuildItemQuery( query, mapParams );
 
                 query.exec();
-    
+
                 if (query.isActive() && query.size() > 0)
                 {
                     if ( query.next() )
@@ -887,31 +887,11 @@
                     }
                 }
             }
+            break;
         }
         case CDS_BrowseDirectChildren:
         {
-
-	    QStringList tokens;
-
-	    if (pRequest->m_sObjectId.length() > 0)
-            {
-                if (pRequest->m_sObjectId.contains("="))
-                    tokens = QStringList::split( "=", pRequest->m_sObjectId );
-	        else 
-	        {
-	             tokens =  QStringList::split( "/", pRequest->m_sObjectId );
-
-	             tokens = QStringList::split( " ", tokens[tokens.count() - 1] );
-                     tokens = QStringList::split( "?", tokens[0] );
-
-                     if (tokens[0].startsWith("Id"))
-                         tokens[0] = tokens[0].right(tokens[0].length() - 2);
-
-	        }	
-            }
-
-            pRequest->m_sParentId = tokens.last();
-            CreateItems( pRequest, pResults, 0, "", false );
+            // Items don't have any children.
             break;
         }
 
@@ -925,7 +905,7 @@
 /////////////////////////////////////////////////////////////////////////////
 
 UPnpCDSExtensionResults *UPnpCDSExtension::ProcessKey( UPnpCDSRequest          *pRequest,
-                                                       UPnpCDSExtensionResults *pResults, 
+                                                       UPnpCDSExtensionResults *pResults,
                                                        QStringList             &idPath )
 {
     pResults->m_nTotalMatches   = 0;
@@ -934,7 +914,7 @@
     // ----------------------------------------------------------------------
     //
     // ----------------------------------------------------------------------
-    
+
     QString sKey = idPath.last().section( '=', 1, 1 );
     QUrl::decode( sKey );
 
@@ -943,10 +923,10 @@
         int nNodeIdx = idPath[ idPath.count() - 2 ].toInt();
 
         switch( pRequest->m_eBrowseFlag )
-        { 
+        {
 
             case CDS_BrowseMetadata:
-            {                              
+            {
                 UPnpCDSRootInfo *pInfo = GetRootInfo( nNodeIdx );
 
                 if (pInfo == NULL)
@@ -984,13 +964,13 @@
                             pResults->m_nTotalMatches   = 1;
                             pResults->m_nUpdateID       = 1;
 
-                            CDSObject *pItem = CreateContainer( pRequest->m_sObjectId,  
-                                                                query.value(1).toString(), 
+                            CDSObject *pItem = CreateContainer( pRequest->m_sObjectId,
+                                                                query.value(1).toString(),
                                                                 pRequest->m_sParentId );
 
                             pItem->SetChildCount( GetDistinctCount( pInfo ));
 
-                            pResults->Add( pItem ); 
+                            pResults->Add( pItem );
                         }
                     }
                 }
@@ -999,7 +979,7 @@
 
             case CDS_BrowseDirectChildren:
             {
-		
+
                 CreateItems( pRequest, pResults, nNodeIdx, sKey, true );
 
                 break;
@@ -1011,7 +991,7 @@
         }
     }
 
-    return pResults;                                                                           
+    return pResults;
 }
 
 /////////////////////////////////////////////////////////////////////////////
@@ -1033,7 +1013,7 @@
         return pResults;
 
     switch( pRequest->m_eBrowseFlag )
-    { 
+    {
         case CDS_BrowseMetadata:
         {
             // --------------------------------------------------------------
@@ -1043,13 +1023,13 @@
             pResults->m_nTotalMatches   = 1;
             pResults->m_nUpdateID       = 1;
 
-            CDSObject *pItem = CreateContainer( pRequest->m_sObjectId,  
-                                                QObject::tr( pInfo->title ), 
+            CDSObject *pItem = CreateContainer( pRequest->m_sObjectId,
+                                                QObject::tr( pInfo->title ),
                                                 m_sExtensionId );
 
             pItem->SetChildCount( GetDistinctCount( pInfo ));
 
-            pResults->Add( pItem ); 
+            pResults->Add( pItem );
 
             break;
         }
@@ -1059,7 +1039,7 @@
             pResults->m_nTotalMatches = GetDistinctCount( pInfo );
             pResults->m_nUpdateID     = 1;
 
-            if (pRequest->m_nRequestedCount == 0) 
+            if (pRequest->m_nRequestedCount == 0)
                 pRequest->m_nRequestedCount = SHRT_MAX;
 
             MSqlQuery query(MSqlQuery::InitCon());
@@ -1085,7 +1065,8 @@
                     while(query.next())
                     {
                         QString sKey   = query.value(0).toString();
-                        QString sTitle = query.value(1).toString();
+                        QString sTitle =
+                                QString::fromUtf8(query.value(1).toString());
                         long    nCount = query.value(2).toInt();
 
                         if (sTitle.length() == 0)
@@ -1099,7 +1080,7 @@
 
                         pRoot->SetChildCount( nCount );
 
-                        pResults->Add( pRoot ); 
+                        pResults->Add( pRoot );
                     }
                 }
             }
@@ -1134,7 +1115,7 @@
         //       for column & table names
 
         QString sSQL;
-        
+
         if (strncmp( pInfo->column, "*", 1) == 0)
         {
             sSQL = QString( "SELECT count( %1 ) FROM %2" )
@@ -1178,7 +1159,7 @@
         //       for column & table names
 
         QString sSQL;
-        
+
         if (sColumn == "*")
             sSQL = QString( "SELECT count( * ) FROM %1" ).arg( GetTableName( sColumn ) );
         else
@@ -1210,7 +1191,7 @@
 void UPnpCDSExtension::CreateItems( UPnpCDSRequest          *pRequest,
                                     UPnpCDSExtensionResults *pResults,
                                     int                      nNodeIdx,
-                                    const QString           &sKey, 
+                                    const QString           &sKey,
                                     bool                     bAddRef )
 {
     pResults->m_nTotalMatches = 0;
@@ -1224,7 +1205,7 @@
     pResults->m_nTotalMatches = GetCount( pInfo->column, sKey );
     pResults->m_nUpdateID     = 1;
 
-    if (pRequest->m_nRequestedCount == 0) 
+    if (pRequest->m_nRequestedCount == 0)
         pRequest->m_nRequestedCount = SHRT_MAX;
 
     MSqlQuery query(MSqlQuery::InitCon());
@@ -1251,7 +1232,7 @@
 
         if (query.isActive() && query.size() > 0)
         {
-            while(query.next()) 
+            while(query.next())
                 AddItem( pRequest->m_sObjectId, pResults, bAddRef, query );
 
         }
diff -uNr mythtv-0.21/libs/libmythupnp/upnpcds.h mythtv/libs/libmythupnp/upnpcds.h
--- mythtv-0.21/libs/libmythupnp/upnpcds.h	2008-03-02 22:14:41.000000000 +0100
+++ mythtv/libs/libmythupnp/upnpcds.h	2008-03-15 18:53:54.000000000 +0100
@@ -124,22 +124,22 @@
 
         QString RemoveToken ( const QString &sToken, const QString &sStr, int num );
 
-        UPnpCDSExtensionResults *ProcessRoot     ( UPnpCDSRequest          *pRequest, 
-                                                   UPnpCDSExtensionResults *pResults,
-                                                   QStringList             &idPath );
-        UPnpCDSExtensionResults *ProcessAll      ( UPnpCDSRequest          *pRequest, 
-                                                   UPnpCDSExtensionResults *pResults,
-                                                   QStringList             &idPath );
-        UPnpCDSExtensionResults *ProcessItem     ( UPnpCDSRequest          *pRequest,
-                                                   UPnpCDSExtensionResults *pResults,
-                                                   QStringList             &idPath );
-        UPnpCDSExtensionResults *ProcessKey      ( UPnpCDSRequest          *pRequest,
-                                                   UPnpCDSExtensionResults *pResults,
-                                                   QStringList             &idPath );
-        UPnpCDSExtensionResults *ProcessContainer( UPnpCDSRequest          *pRequest,
-                                                   UPnpCDSExtensionResults *pResults,
-                                                   int                      nNodeIdx,
-                                                   QStringList             &idPath );
+        virtual UPnpCDSExtensionResults *ProcessRoot     ( UPnpCDSRequest          *pRequest, 
+                                                           UPnpCDSExtensionResults *pResults,
+                                                           QStringList             &idPath );
+        virtual UPnpCDSExtensionResults *ProcessAll      ( UPnpCDSRequest          *pRequest, 
+                                                           UPnpCDSExtensionResults *pResults,
+                                                           QStringList             &idPath );
+        virtual UPnpCDSExtensionResults *ProcessItem     ( UPnpCDSRequest          *pRequest,
+                                                           UPnpCDSExtensionResults *pResults,
+                                                           QStringList             &idPath );
+        virtual UPnpCDSExtensionResults *ProcessKey      ( UPnpCDSRequest          *pRequest,
+                                                           UPnpCDSExtensionResults *pResults,
+                                                           QStringList             &idPath );
+        virtual UPnpCDSExtensionResults *ProcessContainer( UPnpCDSRequest          *pRequest,
+                                                           UPnpCDSExtensionResults *pResults,
+                                                           int                      nNodeIdx,
+                                                           QStringList             &idPath );
 
         // ------------------------------------------------------------------
 
diff -uNr mythtv-0.21/libs/libs-dephack.pro mythtv/libs/libs-dephack.pro
--- mythtv-0.21/libs/libs-dephack.pro	2008-01-25 10:32:50.000000000 +0100
+++ mythtv/libs/libs-dephack.pro	2008-06-04 06:05:51.000000000 +0200
@@ -8,9 +8,6 @@
     # Worked around by building libmyth first,
     # with dlltool faking the symbols from the other two libs
     LIBS += -L../libmyth -lmyth-$$LIBVERSION
-
-    # For easier debugging, put lib in same place as mythfrontend.exe
-    target.path = $${PREFIX}/bin
 }
 
 #unix {
